Blame


1 0e673013 2019-01-02 stsp #!/bin/sh
2 0e673013 2019-01-02 stsp #
3 5aa81393 2020-01-06 stsp # Copyright (c) 2019, 2020 Stefan Sperling <stsp@openbsd.org>
4 0e673013 2019-01-02 stsp #
5 0e673013 2019-01-02 stsp # Permission to use, copy, modify, and distribute this software for any
6 0e673013 2019-01-02 stsp # purpose with or without fee is hereby granted, provided that the above
7 0e673013 2019-01-02 stsp # copyright notice and this permission notice appear in all copies.
8 0e673013 2019-01-02 stsp #
9 0e673013 2019-01-02 stsp # THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
10 0e673013 2019-01-02 stsp # WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
11 0e673013 2019-01-02 stsp # MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
12 0e673013 2019-01-02 stsp # ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
13 0e673013 2019-01-02 stsp # WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
14 0e673013 2019-01-02 stsp # ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
15 0e673013 2019-01-02 stsp # OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
16 0e673013 2019-01-02 stsp
17 f81387ac 2023-02-17 thomas regress_run_only=""
18 f81387ac 2023-02-17 thomas
19 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_NAME="Flan Hacker"
20 0b2899f8 2019-08-18 stsp export GIT_AUTHOR_EMAIL="flan_hacker@openbsd.org"
21 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_NAME="$GIT_AUTHOR_NAME"
22 0b2899f8 2019-08-18 stsp export GIT_COMMITTER_EMAIL="$GIT_AUTHOR_EMAIL"
23 0b2899f8 2019-08-18 stsp export GOT_AUTHOR="$GIT_AUTHOR_NAME <$GIT_AUTHOR_EMAIL>"
24 82f6abb8 2019-08-14 stsp export GOT_AUTHOR_8="flan_hac"
25 e600f124 2021-03-21 stsp export GOT_AUTHOR_11="flan_hacker"
26 b1ebc001 2019-08-13 stsp export GOT_LOG_DEFAULT_LIMIT=0
27 11f4fa81 2020-10-01 stsp export GOT_TEST_ROOT="/tmp"
28 1f240092 2022-07-24 thomas export GOT_IGNORE_GITCONFIG=1
29 113392cf 2023-01-23 thomas export GOT_VERSION_STR=`got --version | cut -d ' ' -f2`
30 e4db89da 2023-03-05 thomas
31 e4db89da 2023-03-05 thomas export LC_ALL=C
32 c3754a5b 2019-05-10 stsp
33 7b67836a 2019-05-10 stsp export MALLOC_OPTIONS=S
34 d3b82051 2022-07-10 thomas
35 e33b5f97 2023-03-05 thomas if [ "$(date -u -r 86400 +%F 2>/dev/null)" != 1970-01-02 ]; then
36 e33b5f97 2023-03-05 thomas DATECMD=
37 e33b5f97 2023-03-05 thomas for p in date gdate; do
38 e33b5f97 2023-03-05 thomas if [ "$($p -u -d @86400 +%F 2>/dev/null)" = 1970-01-02 ]; then
39 e33b5f97 2023-03-05 thomas DATECMD=$p
40 e33b5f97 2023-03-05 thomas break
41 e33b5f97 2023-03-05 thomas fi
42 1c72bab5 2023-03-03 thomas done
43 e33b5f97 2023-03-05 thomas if [ -z "$DATECMD" ]; then
44 e33b5f97 2023-03-05 thomas echo "Couldn't find gdate, is GNU coreutils installed?" >&2
45 e33b5f97 2023-03-05 thomas exit 1
46 e33b5f97 2023-03-05 thomas fi
47 fa37079f 2021-10-09 thomas
48 e33b5f97 2023-03-05 thomas date()
49 e33b5f97 2023-03-05 thomas {
50 e33b5f97 2023-03-05 thomas local flag r u
51 e33b5f97 2023-03-05 thomas while getopts r:u flag; do
52 e33b5f97 2023-03-05 thomas case $flag in
53 e33b5f97 2023-03-05 thomas r) r=$OPTARG ;;
54 e33b5f97 2023-03-05 thomas u) u=-u ;;
55 e33b5f97 2023-03-05 thomas ?) exit 1 ;;
56 e33b5f97 2023-03-05 thomas esac
57 e33b5f97 2023-03-05 thomas done
58 e33b5f97 2023-03-05 thomas shift $((OPTIND - 1))
59 e33b5f97 2023-03-05 thomas command "$DATECMD" $u ${r+-d"@$r"} "$@"
60 e33b5f97 2023-03-05 thomas }
61 e33b5f97 2023-03-05 thomas fi
62 e33b5f97 2023-03-05 thomas
63 f6cae3ed 2020-09-13 naddy git_init()
64 0e673013 2019-01-02 stsp {
65 0b2899f8 2019-08-18 stsp git init -q "$1"
66 f60607c8 2021-09-30 thomas
67 f60607c8 2021-09-30 thomas # Switch the default branch to match our test expectations if needed.
68 f60607c8 2021-09-30 thomas # Only need to change HEAD since 'git init' did not create any refs.
69 f60607c8 2021-09-30 thomas # Relying on implementation details of 'git init' is no problem for us.
70 f60607c8 2021-09-30 thomas # We want to be alerted when Git changes fundamental assumptions such
71 f60607c8 2021-09-30 thomas # as what an empty repository looks like and where the default branch
72 f60607c8 2021-09-30 thomas # is set. In such cases Got's own tooling might well need to change
73 f60607c8 2021-09-30 thomas # its behaviour, too, and our tests should fail.
74 f60607c8 2021-09-30 thomas # TODO: Update all tests to assume 'main' instead of 'master' and
75 f60607c8 2021-09-30 thomas # switch to main here, to match Got's own default.
76 f60607c8 2021-09-30 thomas echo "ref: refs/heads/master" > "$1/.git/HEAD"
77 0e673013 2019-01-02 stsp }
78 0e673013 2019-01-02 stsp
79 f6cae3ed 2020-09-13 naddy maybe_pack_repo()
80 b32c4525 2020-01-05 stsp {
81 b32c4525 2020-01-05 stsp local repo="$1"
82 b32c4525 2020-01-05 stsp if [ -n "$GOT_TEST_PACK" ]; then
83 a628577a 2023-02-17 thomas arg=""
84 a628577a 2023-02-17 thomas if [ "$GOT_TEST_PACK" = "ref-delta" ]; then
85 a628577a 2023-02-17 thomas arg="-D"
86 a628577a 2023-02-17 thomas fi
87 a628577a 2023-02-17 thomas
88 a628577a 2023-02-17 thomas (cd $repo && gotadmin pack -a $arg > /dev/null)
89 a628577a 2023-02-17 thomas (cd $repo && gotadmin cleanup -a -q)
90 b32c4525 2020-01-05 stsp fi
91 b32c4525 2020-01-05 stsp }
92 b32c4525 2020-01-05 stsp
93 f6cae3ed 2020-09-13 naddy git_commit()
94 0e673013 2019-01-02 stsp {
95 0e673013 2019-01-02 stsp local repo="$1"
96 0e673013 2019-01-02 stsp shift
97 d1e03b8c 2023-10-08 thomas git -C $repo commit --author="$GOT_AUTHOR" -q -a "$@"
98 b32c4525 2020-01-05 stsp maybe_pack_repo $repo
99 0e673013 2019-01-02 stsp }
100 0e673013 2019-01-02 stsp
101 f6cae3ed 2020-09-13 naddy git_rm()
102 512f0d0e 2019-01-02 stsp {
103 512f0d0e 2019-01-02 stsp local repo="$1"
104 512f0d0e 2019-01-02 stsp shift
105 d1e03b8c 2023-10-08 thomas git -C $repo rm -q "$@"
106 512f0d0e 2019-01-02 stsp }
107 512f0d0e 2019-01-02 stsp
108 870ddae5 2023-03-10 thomas git_rmdir()
109 870ddae5 2023-03-10 thomas {
110 870ddae5 2023-03-10 thomas local repo="$1"
111 870ddae5 2023-03-10 thomas shift
112 d1e03b8c 2023-10-08 thomas git -C $repo rm -q -r "$@"
113 870ddae5 2023-03-10 thomas }
114 870ddae5 2023-03-10 thomas
115 f6cae3ed 2020-09-13 naddy git_show_head()
116 9c4b8182 2019-01-02 stsp {
117 9c4b8182 2019-01-02 stsp local repo="$1"
118 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%H'
119 9c4b8182 2019-01-02 stsp }
120 9c4b8182 2019-01-02 stsp
121 f6cae3ed 2020-09-13 naddy git_show_branch_head()
122 db32465d 2020-02-07 stsp {
123 db32465d 2020-02-07 stsp local repo="$1"
124 db32465d 2020-02-07 stsp local branch="$2"
125 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%H' $branch
126 db32465d 2020-02-07 stsp }
127 db32465d 2020-02-07 stsp
128 db32465d 2020-02-07 stsp
129 f6cae3ed 2020-09-13 naddy git_show_author_time()
130 bcb49d15 2019-08-14 stsp {
131 bcb49d15 2019-08-14 stsp local repo="$1"
132 01073a5d 2019-08-22 stsp local object="$2"
133 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%at' $object
134 bcb49d15 2019-08-14 stsp }
135 bcb49d15 2019-08-14 stsp
136 f6cae3ed 2020-09-13 naddy git_show_tagger_time()
137 8e7bd50a 2019-08-22 stsp {
138 8e7bd50a 2019-08-22 stsp local repo="$1"
139 8e7bd50a 2019-08-22 stsp local tag="$2"
140 d1e03b8c 2023-10-08 thomas git -C $repo cat-file tag $tag | grep ^tagger | \
141 d1e03b8c 2023-10-08 thomas sed -e "s/^tagger $GOT_AUTHOR//" | cut -d' ' -f2
142 8e7bd50a 2019-08-22 stsp }
143 8e7bd50a 2019-08-22 stsp
144 f6cae3ed 2020-09-13 naddy git_show_parent_commit()
145 818c7501 2019-07-11 stsp {
146 818c7501 2019-07-11 stsp local repo="$1"
147 70551d57 2020-04-24 stsp local commit="$2"
148 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%P' $commit
149 818c7501 2019-07-11 stsp }
150 818c7501 2019-07-11 stsp
151 f6cae3ed 2020-09-13 naddy git_show_tree()
152 03415a1a 2019-06-02 stsp {
153 03415a1a 2019-06-02 stsp local repo="$1"
154 d1e03b8c 2023-10-08 thomas git -C $repo show --no-patch --pretty='format:%T'
155 03415a1a 2019-06-02 stsp }
156 03415a1a 2019-06-02 stsp
157 f6cae3ed 2020-09-13 naddy trim_obj_id()
158 818c7501 2019-07-11 stsp {
159 9439a990 2020-09-16 naddy local trimcount=$1
160 9439a990 2020-09-16 naddy local id=$2
161 818c7501 2019-07-11 stsp
162 9439a990 2020-09-16 naddy local pat=""
163 9439a990 2020-09-16 naddy while [ "$trimcount" -gt 0 ]; do
164 818c7501 2019-07-11 stsp pat="[0-9a-f]$pat"
165 9439a990 2020-09-16 naddy trimcount=$((trimcount - 1))
166 818c7501 2019-07-11 stsp done
167 818c7501 2019-07-11 stsp
168 818c7501 2019-07-11 stsp echo ${id%$pat}
169 9139e004 2023-07-17 thomas }
170 9139e004 2023-07-17 thomas
171 8642913b 2023-07-26 thomas pop_idx()
172 9139e004 2023-07-17 thomas {
173 9139e004 2023-07-17 thomas shift "$1"
174 9139e004 2023-07-17 thomas printf '%s' "${1:-index-out-of-bounds}"
175 818c7501 2019-07-11 stsp }
176 818c7501 2019-07-11 stsp
177 f6cae3ed 2020-09-13 naddy git_commit_tree()
178 03415a1a 2019-06-02 stsp {
179 03415a1a 2019-06-02 stsp local repo="$1"
180 03415a1a 2019-06-02 stsp local msg="$2"
181 03415a1a 2019-06-02 stsp local tree="$3"
182 d1e03b8c 2023-10-08 thomas git -C $repo commit-tree -m "$msg" "$tree"
183 03415a1a 2019-06-02 stsp }
184 03415a1a 2019-06-02 stsp
185 f0fd0aaf 2021-09-14 stsp git_fsck()
186 f0fd0aaf 2021-09-14 stsp {
187 f0fd0aaf 2021-09-14 stsp local testroot="$1"
188 f0fd0aaf 2021-09-14 stsp local repo="$2"
189 f0fd0aaf 2021-09-14 stsp
190 d1e03b8c 2023-10-08 thomas git -C $repo fsck --strict \
191 d1e03b8c 2023-10-08 thomas > $testroot/fsck.stdout 2> $testroot/fsck.stderr
192 fc414659 2022-04-16 thomas ret=$?
193 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
194 f0fd0aaf 2021-09-14 stsp echo -n "git fsck: "
195 f0fd0aaf 2021-09-14 stsp cat $testroot/fsck.stderr
196 f0fd0aaf 2021-09-14 stsp echo "git fsck failed; leaving test data in $testroot"
197 f0fd0aaf 2021-09-14 stsp return 1
198 f0fd0aaf 2021-09-14 stsp fi
199 f0fd0aaf 2021-09-14 stsp
200 f0fd0aaf 2021-09-14 stsp return 0
201 f0fd0aaf 2021-09-14 stsp }
202 f0fd0aaf 2021-09-14 stsp
203 f6cae3ed 2020-09-13 naddy make_test_tree()
204 0e673013 2019-01-02 stsp {
205 0e673013 2019-01-02 stsp repo="$1"
206 0e673013 2019-01-02 stsp
207 0e673013 2019-01-02 stsp echo alpha > $repo/alpha
208 0e673013 2019-01-02 stsp echo beta > $repo/beta
209 0e673013 2019-01-02 stsp mkdir $repo/gamma
210 0e673013 2019-01-02 stsp echo delta > $repo/gamma/delta
211 0e673013 2019-01-02 stsp mkdir $repo/epsilon
212 0e673013 2019-01-02 stsp echo zeta > $repo/epsilon/zeta
213 0e673013 2019-01-02 stsp }
214 0e673013 2019-01-02 stsp
215 f6cae3ed 2020-09-13 naddy make_single_file_repo()
216 e7303626 2020-05-14 stsp {
217 e7303626 2020-05-14 stsp repo="$1"
218 e7303626 2020-05-14 stsp file="$2"
219 e7303626 2020-05-14 stsp
220 e7303626 2020-05-14 stsp mkdir $repo
221 e7303626 2020-05-14 stsp git_init $repo
222 e7303626 2020-05-14 stsp echo "this is file $file" > $repo/$file
223 d1e03b8c 2023-10-08 thomas git -C $repo add .
224 e7303626 2020-05-14 stsp git_commit $repo -m "intialize $repo with file $file"
225 e7303626 2020-05-14 stsp }
226 e7303626 2020-05-14 stsp
227 f6cae3ed 2020-09-13 naddy get_loose_object_path()
228 e7303626 2020-05-14 stsp {
229 e7303626 2020-05-14 stsp local repo="$1"
230 e7303626 2020-05-14 stsp local id="$2"
231 e7303626 2020-05-14 stsp local id0=`trim_obj_id 38 $id`
232 e7303626 2020-05-14 stsp local idrest=`echo ${id#[0-9a-f][0-9a-f]}`
233 e7303626 2020-05-14 stsp echo "$repo/.git/objects/$id0/$idrest"
234 e7303626 2020-05-14 stsp }
235 e7303626 2020-05-14 stsp
236 f6cae3ed 2020-09-13 naddy get_blob_id()
237 3ce1b845 2019-07-15 stsp {
238 3ce1b845 2019-07-15 stsp repo="$1"
239 3ce1b845 2019-07-15 stsp tree_path="$2"
240 3ce1b845 2019-07-15 stsp filename="$3"
241 3ce1b845 2019-07-15 stsp
242 e8863bdc 2020-07-23 stsp got tree -r $repo -i $tree_path | grep "[0-9a-f] ${filename}$" | \
243 e8863bdc 2020-07-23 stsp cut -d' ' -f 1
244 3ce1b845 2019-07-15 stsp }
245 3ce1b845 2019-07-15 stsp
246 f6cae3ed 2020-09-13 naddy test_init()
247 0e673013 2019-01-02 stsp {
248 0e673013 2019-01-02 stsp local testname="$1"
249 4a1ddfc2 2019-01-12 stsp local no_tree="$2"
250 0e673013 2019-01-02 stsp if [ -z "$testname" ]; then
251 0e673013 2019-01-02 stsp echo "No test name provided" >&2
252 0e673013 2019-01-02 stsp return 1
253 0e673013 2019-01-02 stsp fi
254 d6e78555 2023-06-01 thomas local testroot=`mktemp -d \
255 d6e78555 2023-06-01 thomas "$GOT_TEST_ROOT/got-test-$testname-XXXXXXXXXX"`
256 0e673013 2019-01-02 stsp mkdir $testroot/repo
257 0e673013 2019-01-02 stsp git_init $testroot/repo
258 4a1ddfc2 2019-01-12 stsp if [ -z "$no_tree" ]; then
259 4a1ddfc2 2019-01-12 stsp make_test_tree $testroot/repo
260 d1e03b8c 2023-10-08 thomas git -C $repo add .
261 4a1ddfc2 2019-01-12 stsp git_commit $testroot/repo -m "adding the test tree"
262 4a1ddfc2 2019-01-12 stsp fi
263 c8c71e6e 2020-03-21 stsp touch $testroot/repo/.git/git-daemon-export-ok
264 0e673013 2019-01-02 stsp echo "$testroot"
265 0e673013 2019-01-02 stsp }
266 0e673013 2019-01-02 stsp
267 f6cae3ed 2020-09-13 naddy test_cleanup()
268 0e673013 2019-01-02 stsp {
269 0e673013 2019-01-02 stsp local testroot="$1"
270 fe7842f5 2019-07-14 stsp
271 f0fd0aaf 2021-09-14 stsp git_fsck $testroot $testroot/repo
272 fc414659 2022-04-16 thomas ret=$?
273 fc414659 2022-04-16 thomas if [ $ret -ne 0 ]; then
274 f0fd0aaf 2021-09-14 stsp return $ret
275 fe7842f5 2019-07-14 stsp fi
276 fe7842f5 2019-07-14 stsp
277 0e673013 2019-01-02 stsp rm -rf "$testroot"
278 0e673013 2019-01-02 stsp }
279 0e673013 2019-01-02 stsp
280 f6cae3ed 2020-09-13 naddy test_parseargs()
281 7fb414ae 2020-08-08 stsp {
282 6c8da0c6 2020-10-03 naddy while getopts qr: flag; do
283 6c8da0c6 2020-10-03 naddy case $flag in
284 6c8da0c6 2020-10-03 naddy q) export GOT_TEST_QUIET=1
285 6c8da0c6 2020-10-03 naddy ;;
286 4f3c3d1e 2023-01-10 thomas r) export GOT_TEST_ROOT=${OPTARG%/}
287 6c8da0c6 2020-10-03 naddy ;;
288 6c8da0c6 2020-10-03 naddy ?) echo "Supported options:"
289 6c8da0c6 2020-10-03 naddy echo " -q: quiet mode"
290 6c8da0c6 2020-10-03 naddy echo " -r PATH: use PATH as test data root directory"
291 6c8da0c6 2020-10-03 naddy exit 2
292 6c8da0c6 2020-10-03 naddy ;;
293 7fb414ae 2020-08-08 stsp esac
294 7fb414ae 2020-08-08 stsp done
295 f81387ac 2023-02-17 thomas shift $(($OPTIND - 1))
296 f81387ac 2023-02-17 thomas regress_run_only="$@"
297 6c8da0c6 2020-10-03 naddy } >&2
298 7fb414ae 2020-08-08 stsp
299 f6cae3ed 2020-09-13 naddy run_test()
300 0e673013 2019-01-02 stsp {
301 0e673013 2019-01-02 stsp testfunc="$1"
302 f81387ac 2023-02-17 thomas
303 f81387ac 2023-02-17 thomas if [ -n "$regress_run_only" ]; then
304 f81387ac 2023-02-17 thomas case "$regress_run_only" in
305 f81387ac 2023-02-17 thomas *$testfunc*) ;;
306 f81387ac 2023-02-17 thomas *) return ;;
307 f81387ac 2023-02-17 thomas esac
308 f81387ac 2023-02-17 thomas fi
309 f81387ac 2023-02-17 thomas
310 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
311 7fb414ae 2020-08-08 stsp echo -n "$testfunc "
312 7fb414ae 2020-08-08 stsp fi
313 0e673013 2019-01-02 stsp $testfunc
314 0e673013 2019-01-02 stsp }
315 0e673013 2019-01-02 stsp
316 f6cae3ed 2020-09-13 naddy test_done()
317 0e673013 2019-01-02 stsp {
318 0e673013 2019-01-02 stsp local testroot="$1"
319 0e673013 2019-01-02 stsp local result="$2"
320 54c39596 2020-12-28 stsp if [ "$result" = "0" ]; then
321 fe7842f5 2019-07-14 stsp test_cleanup "$testroot" || return 1
322 7fb414ae 2020-08-08 stsp if [ -z "$GOT_TEST_QUIET" ]; then
323 7fb414ae 2020-08-08 stsp echo "ok"
324 7fb414ae 2020-08-08 stsp fi
325 3941b73a 2019-05-14 stsp elif echo "$result" | grep -q "^xfail"; then
326 3941b73a 2019-05-14 stsp # expected test failure; test reproduces an unfixed bug
327 3941b73a 2019-05-14 stsp echo "$result"
328 17201126 2019-07-14 stsp test_cleanup "$testroot" || return 1
329 0e673013 2019-01-02 stsp else
330 0e673013 2019-01-02 stsp echo "test failed; leaving test data in $testroot"
331 0e673013 2019-01-02 stsp fi
332 0e673013 2019-01-02 stsp }